import "JackdawPlugins.Libs.QBar"

--[[**NewQPopUpBar
Creates a new popup bar.

NO LONGER A SEPERATE LIBRARY.

This new version only uses ONE window - not several. This can create... problems. But should be OK!

Example Use; Testpop=NewQPopUpBar {x=100,y=100,orientation="t",length=10,dragbar=false}

NOTE: There is nothing to stop a popup being 2d - but I have not developed this.

Options;
		x,y				Location	Default 100,100
		length			Length of the bar
		orientation	where is the pop-up button?													*l*eft *r*ight *t*op or *b* bottom. Default b
		dragbar		whether to have a dragbar or not											Default true
]]--

	NewQPopUpBar=class()--Turbine.UI.Control) --Can this be changed to just class()?
function NewQPopUpBar:Constructor (options)
		self.options=options
		local x=options.x or 100
		local y=options.y or 100
		local size=35 															-- leave like this for now till Turbine add support!
		local length=options.length or 3
		local orientation= options.orientation or "b"
		local gap=0 
		local pad=0
		if options.dragbar==nil then options.dragbar=true end

		--Build the parent bar
			--Calculate sizes
			local sx
			local sy
			if (orientation == "t") or (orientation =="b" )then
				 sx=1
				 sy=length+1
			else
				 sx=length+1
				 sy=1
			end
			
		--Create the bar using the QBar class
			--Must include all the options that need preserving that are not normally a part of QBars
			JackdawPlugins.Libs.NewQBar(self,{x=x,y=y,sx=sx,sy=sy,colour=Turbine.UI.Color(0,0,0,0),name=options.name or "Pop Up", dragbar=dragbar, gap=gap, pad=pad, length=length, orientation=orientation})
		--Make the back window mouse invisible
		self.Window:SetMouseVisible(false)

		--Assign Dragbar to parent
			if options.dragbar then import "Deusdictum.UI.Dragbar" self.Window.DragBar = Deusdictum.UI.DragBar( self.Window, options.name or "PopUp"); end
			
		--***Register click events***
		self:Events()
		
		--**Register window events**
			--Register to change options.x and options.y if the frame is moved.
			self.Window.PositionChanged = function( sender, args ) 
			self.options.x,self.options.y=self.Window:GetPosition()
			end

			--Register to update events on size change.
			self.Window.SizeChanged =function(sender,args)
			--First two lines are from the equivalent function in QBar
				JackdawPlugins.Libs.QBarSizeChanged(self.Quickslot,self.Window)
				if self.Window.DragBar~=nil then self.Window.DragBar:RecalculateSize() end
				self:Events()
				self.options.length=#self.Quickslot-1
				--Now fix the pop-up Button
				local popbuttonindex=self.options.popbuttonindex
				local x,y=self.Quickslot[popbuttonindex]:GetPosition()
				self.button:SetPosition(x+1,y+1)
			end
end	

function NewQPopUpBar:Events()
			--Register the MouseClick events for the quickslots.
			
			local orientation = self.options.orientation
			local length= self.options.length
			
			--Which quickslot is the pop-up button?
			if 				orientation=="l" then popbuttonindex=1
				elseif	orientation=="r" then popbuttonindex=length+1
				elseif	orientation=="t" then popbuttonindex=1
				elseif	orientation=="b" then popbuttonindex=length+1
			end
			--Record this in the options table to make it easier to use later
			self.options.popbuttonindex=popbuttonindex

				for i = 1,#self.Quickslot do
					if i~=popbuttonindex then
						--This is one of the pop-up quickslots; Register its click events
						self.Quickslot[i]:SetBackColor (Turbine.UI.Color( 0,0, 0, 0))
						self.Quickslot[i].MouseClick = function( sender, args )
							--If the shift key is being held use to clear the shortcut instead.
							if self.Quickslot[i].IsShiftKeyDown() then
								self.Quickslot[i]:SetShortcut()
							else
							--Turbine.Shell.WriteLine("Clickety")
							--Copy to the Pop-Up button
								self.Quickslot[popbuttonindex]:SetShortcut(self.Quickslot[i]:GetShortcut()) --Get shortcut from target and set to button
								--Hide the all the popup quickslots.
								self:Close()
							end
						end
					else
						--This is the pop-up Button itself.
						self.Quickslot[popbuttonindex]:SetBackColor (Turbine.UI.Color( 0.8,0, 0, 0))  -- Faded Black backdrop
						-- Register to pop up the bar when right clicked
						self.Quickslot[popbuttonindex].MouseClick = function( sender, args ) 
							if ( args.Button == Turbine.UI.MouseButton.Right ) then
								self:Toggle()
							end
						end
					end	

			end
	end
	
function NewQPopUpBar:Close()
	self.options.open=false
	for i = 1,#self.Quickslot do
		if i~=self.options.popbuttonindex then self.Quickslot[i]:SetVisible(false) end
	end
end

function NewQPopUpBar:Open()
	self.options.open=true
	for i = 1,#self.Quickslot do
		if i~=self.options.popbuttonindex then self.Quickslot[i]:SetVisible(true) end
	end
end

function NewQPopUpBar:Toggle()
	if self.options.open then self:Close() else self:Open() end
end

function NewQPopUpBar:ChangeOrientation(o)
	--Change the orientation of a bar to o
	local oo = self.options.orientation --old orientation
	local length = self.options.length
	
	--Set new orientation
	self.options.orientation=o
	if 	oo=="l" then					
		if 			o=="r" then										self:SwopSlots()
		elseif 	o=="b" then	self:SwopWindow()		self:SwopSlots()
		elseif 	o=="t" then	self:SwopWindow()
		end
	elseif oo=="r" then
		if 			o=="b" then	self:SwopWindow()
		elseif 	o=="t" then	self:SwopWindow()		self:SwopSlots()
		elseif 	o=="l" then										self:SwopSlots()
		end
	elseif oo=="b" then
		if 			o=="t" then										self:SwopSlots()
		elseif 	o=="l" then	self:SwopWindow()		self:SwopSlots()
		elseif 	o=="r" then	self:SwopWindow()
		end
	elseif oo=="t" then
		if 			o=="l" then	self:SwopWindow()								
		elseif 	o=="r" then	self:SwopWindow()		self:SwopSlots()
		elseif 	o=="b" then										self:SwopSlots()
		end
	end
	self:Events()
end
function NewQPopUpBar:SwopWindow()
--Swops the window around. SX<>SY
		self.Window:SetSize(self.Window:GetHeight(),self.Window:GetWidth())
end		
function NewQPopUpBar:SwopSlots()
	--Oh no! We need to mess about with shortcuts a little... And reverse them!
		local oldshortcut={}
		for i=1, #self.Quickslot do
			oldshortcut[i]=self.Quickslot[i]:GetShortcut()
		end
		for i=1, #self.Quickslot do
			self.Quickslot[i]:SetShortcut(oldshortcut[#self.Quickslot-i+1])
		end
end

function NewQPopUpBar:Change(len,o)
if o~=nil then self:ChangeOrientation(o) return end

self.options.length=self.options.length+len
local length=self.options.length

			local sx
			local sy
			local size=self.options.size or 35
			local gap=self.options.gap or 0
			local pad=self.options.pad or 0
			if ( self.options.orientation == "t") or ( self.options.orientation =="b" )then
				 sx=1
				 sy=length+1
			else
				 sx=length+1
				 sy=1
			end
			
			self.Window:SetSize(sx*(gap+size)+2*pad,sy*(gap+size)+2*pad)
end

